package dns

import (
	"net"
	"testing"

	osm "git.loafle.net/overflow/service_matcher-go"
)

func TestDns(t *testing.T) {
	m := NewMatcher()

	conn, err := net.Dial("udp", "192.168.1.254:53")
	if err != nil {
		t.Error(err)
		return
	}
	defer conn.Close()

	matchCtx := osm.NewMatchCtx("192.168.1.254", 53)

	for i := 0; i < m.PacketCount(matchCtx); i++ {
		if m.IsSend(53) != true {
			t.Error("not port")
		}
		pack := m.Packet(matchCtx, i)
		conn.Write(pack.Buffer)
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := osm.NewPacket(bytes, n)

		if err := m.Match(nil, 0, p); err != nil {
			t.Error(err)
		}
	}

	t.Log(matchCtx)
}
