package mysql

import (
	"net"
	"testing"

	osm "git.loafle.net/overflow/service_matcher-go"
)

func TestMySql(t *testing.T) {

	m := NewMatcher()

	conn, err := net.Dial("tcp", "192.168.1.201:23306")
	if err != nil {
		t.Errorf("ERR %s", err)
	}
	defer conn.Close()

	matchCtx := osm.NewMatchCtx("192.168.1.201", 23306)

	bytes := make([]byte, 1024)
	n, _ := conn.Read(bytes)
	p := osm.NewPacket(bytes, n)

	if err := m.Match(nil, 0, p); err != nil {
		t.Error(err)
	}
	t.Log(m.Name(matchCtx))
	t.Log(matchCtx)

}
